package org.apache.bcel.classfile;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.DataInput;

public final class ConstantInteger extends Constant implements ConstantObject
{
    private int bytes;
    
    public ConstantInteger(final ConstantInteger c) {
        this(c.getBytes());
    }
    
    ConstantInteger(final DataInput file) throws IOException {
        this(file.readInt());
    }
    
    public ConstantInteger(final int bytes) {
        super((byte)3);
        this.bytes = bytes;
    }
    
    @Override
    public void accept(final Visitor v) {
        v.visitConstantInteger(this);
    }
    
    @Override
    public void dump(final DataOutputStream file) throws IOException {
        file.writeByte(super.getTag());
        file.writeInt(this.bytes);
    }
    
    public int getBytes() {
        return this.bytes;
    }
    
    @Override
    public Object getConstantValue(final ConstantPool cp) {
        return this.bytes;
    }
    
    public void setBytes(final int bytes) {
        this.bytes = bytes;
    }
    
    @Override
    public String toString() {
        return super.toString() + "(bytes = " + this.bytes + ")";
    }
}
